VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cVersion"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Type VS_FIXEDFILEINFO
    dwSignature As Long
    dwStrucVersionl As Integer     '  e.g. = &h0000 = 0
    dwStrucVersionh As Integer     '  e.g. = &h0042 = .42
    dwFileVersionMSl As Integer    '  e.g. = &h0003 = 3
    dwFileVersionMSh As Integer    '  e.g. = &h0075 = .75
    dwFileVersionLSl As Integer    '  e.g. = &h0000 = 0
    dwFileVersionLSh As Integer    '  e.g. = &h0031 = .31
    dwProductVersionMSl As Integer '  e.g. = &h0003 = 3
    dwProductVersionMSh As Integer '  e.g. = &h0010 = .1
    dwProductVersionLSl As Integer '  e.g. = &h0000 = 0
    dwProductVersionLSh As Integer '  e.g. = &h0031 = .31
    dwFileFlagsMask As Long        '  = &h3F for version "0.42"
    dwFileFlags As Long            '  e.g. VFF_DEBUG Or VFF_PRERELEASE
    dwFileOS As Long               '  e.g. VOS_DOS_WINDOWS16
    dwFileType As Long             '  e.g. VFT_DRIVER
    dwFileSubtype As Long          '  e.g. VFT2_DRV_KEYBOARD
    dwFileDateMS As Long           '  e.g. 0
    dwFileDateLS As Long           '  e.g. 0
End Type

Private Declare Function GetFileVersionInfo Lib "Version.dll" Alias _
   "GetFileVersionInfoA" (ByVal lptstrFilename As String, ByVal _
   dwhandle As Long, ByVal dwlen As Long, lpData As Any) As Long
Private Declare Function GetFileVersionInfoSize Lib "Version.dll" Alias _
   "GetFileVersionInfoSizeA" (ByVal lptstrFilename As String, _
   lpdwHandle As Long) As Long
Private Declare Function VerQueryValue Lib "Version.dll" Alias _
   "VerQueryValueA" (pBlock As Any, ByVal lpSubBlock As String, _
   lplpBuffer As Any, puLen As Long) As Long
Private Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" _
   (dest As Any, ByVal Source As Long, ByVal length As Long)
Private Declare Function GetSystemDirectory Lib "kernel32" Alias _
   "GetSystemDirectoryA" (ByVal Path As String, ByVal cbBytes As Long) As Long

' ----- VS_VERSION.dwFileFlags -----
Private Const VS_FFI_SIGNATURE = &HFEEF04BD
Private Const VS_FFI_STRUCVERSION = &H10000
Private Const VS_FFI_FILEFLAGSMASK = &H3F&

' ----- VS_VERSION.dwFileFlags -----
Private Const VS_FF_DEBUG = &H1
Private Const VS_FF_PRERELEASE = &H2
Private Const VS_FF_PATCHED = &H4
Private Const VS_FF_PRIVATEBUILD = &H8
Private Const VS_FF_INFOINFERRED = &H10
Private Const VS_FF_SPECIALBUILD = &H20

' ----- VS_VERSION.dwFileOS -----
Private Const VOS_UNKNOWN = &H0
Private Const VOS_DOS = &H10000
Private Const VOS_OS216 = &H20000
Private Const VOS_OS232 = &H30000
Private Const VOS_NT = &H40000
Private Const VOS_BASE = &H0
Private Const VOS_WINDOWS16 = &H1
Private Const VOS_PM16 = &H2
Private Const VOS_PM32 = &H3
Private Const VOS_WINDOWS32 = &H4

Private Const VOS_DOS_WINDOWS16 = &H10001
Private Const VOS_DOS_WINDOWS32 = &H10004
Private Const VOS_OS216_PM16 = &H20002
Private Const VOS_OS232_PM32 = &H30003
Private Const VOS_NT_WINDOWS32 = &H40004


' ----- VS_VERSION.dwFileType -----
Private Const VFT_UNKNOWN = &H0
Private Const VFT_APP = &H1
Private Const VFT_DLL = &H2
Private Const VFT_DRV = &H3
Private Const VFT_FONT = &H4
Private Const VFT_VXD = &H5
Private Const VFT_STATIC_LIB = &H7

' ----- VS_VERSION.dwFileSubtype for VFT_WINDOWS_DRV -----
Private Const VFT2_UNKNOWN = &H0
Private Const VFT2_DRV_PRINTER = &H1
Private Const VFT2_DRV_KEYBOARD = &H2
Private Const VFT2_DRV_LANGUAGE = &H3
Private Const VFT2_DRV_DISPLAY = &H4
Private Const VFT2_DRV_MOUSE = &H5
Private Const VFT2_DRV_NETWORK = &H6
Private Const VFT2_DRV_SYSTEM = &H7
Private Const VFT2_DRV_INSTALLABLE = &H8
Private Const VFT2_DRV_SOUND = &H9
Private Const VFT2_DRV_COMM = &HA

Private Const VFT2_FONT_RASTER = &H1&
Private Const VFT2_FONT_TRUETYPE = &H3&
Private Const VFT2_FONT_VECTOR = &H2&


'local variable(s) to hold property value(s)
Private mvarFileMajor       As Integer 'local copy
Private mvarFileMinor       As Integer 'local copy
Private mvarFileRevision    As Integer 'local copy
Private mvarFileBuild       As Integer 'local copy
Private mvarProductMajor    As Integer 'local copy
Private mvarProductMinor    As Integer 'local copy
Private mvarProductRevision As Integer 'local copy
Private mvarProductBuild    As Integer 'local copy
Private mvarFileFlags       As Long 'local copy
Private mvarFileFlagsMask   As Long 'local copy
Private mvarFileOS          As Long 'local copy
Private mvarFileOSString    As String 'local copy
Private mvarFileType        As Long 'local copy
Private mvarFileTypeString  As String 'local copy
Private mvarFileSubType     As Long 'local copy
Private mvarFileSubTypeString   As String 'local copy
Private mvarFileDateTimeStamp   As Date     'local copy

Private mvarFilename        As String 'local copy
Private mvarStructureMajor  As Integer
Private mvarStructureMinor  As Integer
Private mvarFileFlagsString As String

Private Sub ClearProperties()

    mvarFileMajor = 0
    mvarFileMinor = 0
    mvarFileRevision = 0
    mvarFileBuild = 0
    mvarProductMajor = 0
    mvarProductMinor = 0
    mvarProductRevision = 0
    mvarProductBuild = 0
    mvarFileFlags = 0
    mvarFileFlagsMask = 0
    mvarFileOS = 0
    mvarFileOSString = ""
    mvarFileType = 0
    mvarFileTypeString = ""
    mvarFileSubType = 0
    mvarFileSubTypeString = ""
    mvarFileDateTimeStamp = 0
    mvarStructureMajor = 0
    mvarStructureMinor = 0
    mvarFileFlagsString = ""

End Sub

Public Property Get FileFlagsString() As String
    FileFlagsString = mvarFileFlagsString
End Property

Public Property Let Filename(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Filename = 5
    mvarFilename = vData
    UpdateClassWithVersionInfo
End Property

Public Property Get Filename() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Filename
    Filename = mvarFilename
End Property

Public Property Get FileDateTimeStamp() As Date
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FileDate
    FileDateTimeStamp = mvarFileDateTimeStamp
End Property

Public Property Get FileSubTypeString() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FileSubTypeString
    FileSubTypeString = mvarFileSubTypeString
End Property

Public Property Get FileSubType() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FileSubType
    FileSubType = mvarFileSubType
End Property

Public Property Get FileTypeString() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FileTypeString
    FileTypeString = mvarFileTypeString
End Property

Public Property Get FileType() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FileType
    FileType = mvarFileType
End Property

Public Property Get FileOSString() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FileOSString
    FileOSString = mvarFileOSString
End Property

Public Property Get FileOS() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FileOS
    FileOS = mvarFileOS
End Property

Public Property Get FileFlagsMask() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FileFlagsMask
    FileFlagsMask = mvarFileFlagsMask
End Property

Public Property Get FileFlags() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FileFlags
    FileFlags = mvarFileFlags
End Property

Public Property Get FileBuild() As Integer
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Build
    FileBuild = mvarFileBuild
End Property

Public Property Get FileRevision() As Integer
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Revision
    FileRevision = mvarFileRevision
End Property

Public Property Get FileMinor() As Integer
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Minor
    FileMinor = mvarFileMinor
End Property

Public Property Get FileMajor() As Integer
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Major
    FileMajor = mvarFileMajor
End Property



Public Property Get ProductBuild() As Integer
    ProductBuild = mvarProductBuild
End Property

Public Property Get ProductMajor() As Integer
    ProductMajor = mvarProductMajor
End Property

Public Property Get ProductMinor() As Integer
    ProductMinor = mvarProductMinor
End Property

Public Property Get ProductRevision() As Integer
    ProductRevision = mvarProductRevision
End Property


Private Sub UpdateClassWithVersionInfo()

    Dim lngReturn           As Long
    Dim lngDummy            As Long
    Dim strBuffer()         As Byte
    Dim lngBufferLen        As Long
    Dim lngVerPointer       As Long
    Dim udtVerBuffer        As VS_FIXEDFILEINFO
    Dim lngVerBufferLen     As Long
   
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    '   Clear all of the properties now
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    ClearProperties
    
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    '   Get the Size of the FileVersion Structure
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    lngBufferLen = GetFileVersionInfoSize(mvarFilename, lngDummy)
    If lngBufferLen < 1 Then
        MsgBox "No Version Info available!"
        Exit Sub
    End If
    
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    '   Store info to udtVerBuffer struct
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    ReDim strBuffer(lngBufferLen)
    lngReturn = GetFileVersionInfo(mvarFilename, 0&, lngBufferLen, strBuffer(0))
    lngReturn = VerQueryValue(strBuffer(0), "\", lngVerPointer, lngVerBufferLen)
    MoveMemory udtVerBuffer, lngVerPointer, Len(udtVerBuffer)
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    '   Determine Structure Version number - NOT USED
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    mvarStructureMajor = CInt(udtVerBuffer.dwStrucVersionh)
    mvarStructureMinor = CInt(udtVerBuffer.dwStrucVersionl)
    
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    '   Determine File Version number
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    mvarFileMajor = CInt(udtVerBuffer.dwFileVersionMSh)
    mvarFileMinor = CInt(udtVerBuffer.dwFileVersionMSl)
    mvarFileRevision = CInt(udtVerBuffer.dwFileVersionLSh)
    mvarFileBuild = CInt(udtVerBuffer.dwFileVersionLSl)
        
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    '   Determine Product Version number
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    mvarProductMajor = CInt(udtVerBuffer.dwProductVersionMSh)
    mvarProductMinor = CInt(udtVerBuffer.dwProductVersionMSl)
    mvarProductRevision = CInt(udtVerBuffer.dwProductVersionLSh)
    mvarProductBuild = CInt(udtVerBuffer.dwProductVersionLSl)
         
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    '   Determine Boolean attributes of File
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    mvarFileFlagsString = ""
    mvarFileFlags = udtVerBuffer.dwFileFlags
    
    If udtVerBuffer.dwFileFlags And VS_FF_DEBUG Then mvarFileFlagsString = "Debug "
    If udtVerBuffer.dwFileFlags And VS_FF_PRERELEASE _
       Then mvarFileFlagsString = mvarFileFlagsString & "PreRelease "
    If udtVerBuffer.dwFileFlags And VS_FF_PATCHED _
       Then mvarFileFlagsString = mvarFileFlagsString & "Patched "
    If udtVerBuffer.dwFileFlags And VS_FF_PRIVATEBUILD _
       Then mvarFileFlagsString = mvarFileFlagsString & "Private "
    If udtVerBuffer.dwFileFlags And VS_FF_INFOINFERRED _
       Then mvarFileFlagsString = mvarFileFlagsString & "Info "
    If udtVerBuffer.dwFileFlags And VS_FF_SPECIALBUILD _
       Then mvarFileFlagsString = mvarFileFlagsString & "Special "
    If udtVerBuffer.dwFileFlags And VFT2_UNKNOWN _
       Then mvarFileFlagsString = mvarFileFlagsString + "Unknown "
    
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    '   Determine OS for which file was designed
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    mvarFileOS = udtVerBuffer.dwFileOS
    Select Case udtVerBuffer.dwFileOS
        Case VOS_DOS_WINDOWS16
            mvarFileOSString = "DOS-Win16"
        Case VOS_DOS_WINDOWS32
            mvarFileOSString = "DOS-Win32"
        Case VOS_OS216_PM16
            mvarFileOSString = "OS/2-16 PM-16"
        Case VOS_OS232_PM32
            mvarFileOSString = "OS/2-16 PM-32"
        Case VOS_NT_WINDOWS32
            mvarFileOSString = "NT-Win32"
        Case Else
            mvarFileOSString = "Unknown"
    End Select
    
    mvarFileType = udtVerBuffer.dwFileType
    Select Case udtVerBuffer.dwFileType
        Case VFT_APP
            mvarFileTypeString = "Application"
        Case VFT_DLL
            mvarFileTypeString = "DLL"
        Case VFT_DRV
            mvarFileTypeString = "Driver"
            ' Get the driver type
            mvarFileSubType = udtVerBuffer.dwFileSubtype
            Select Case udtVerBuffer.dwFileSubtype
                Case VFT2_DRV_PRINTER
                    mvarFileSubTypeString = "Printer"
                Case VFT2_DRV_KEYBOARD
                    mvarFileSubTypeString = "Keyboard"
                Case VFT2_DRV_LANGUAGE
                    mvarFileSubTypeString = "Language"
                Case VFT2_DRV_DISPLAY
                    mvarFileSubTypeString = "Display"
                Case VFT2_DRV_MOUSE
                    mvarFileSubTypeString = "Mouse"
                Case VFT2_DRV_NETWORK
                    mvarFileSubTypeString = "Network"
                Case VFT2_DRV_SYSTEM
                    mvarFileSubTypeString = "System"
                Case VFT2_DRV_INSTALLABLE
                    mvarFileSubTypeString = "Installable"
                Case VFT2_DRV_SOUND
                    mvarFileSubTypeString = "Sound"
                Case VFT2_DRV_COMM
                    mvarFileSubTypeString = "Comm drv"
                Case VFT2_UNKNOWN
                    mvarFileSubTypeString = "Unknown"
            End Select
            
        Case VFT_FONT
            mvarFileTypeString = "Font"
            ' Get the Font Type
            Select Case udtVerBuffer.dwFileSubtype
                Case VFT2_FONT_RASTER
                    mvarFileSubTypeString = "Raster Font"
                Case VFT2_FONT_VECTOR
                    mvarFileSubTypeString = "Vector Font"
                Case VFT2_FONT_TRUETYPE
                    mvarFileSubTypeString = "TrueType Font"
            End Select
        Case VFT_VXD
            mvarFileTypeString = "VxD"
        Case VFT_STATIC_LIB
            mvarFileTypeString = "Lib"
        Case Else
            mvarFileTypeString = "Unknown"
    End Select
    
    On Error Resume Next
    mvarFileDateTimeStamp = FileDateTime(mvarFilename)
    On Error GoTo 0
End Sub


